package ru.dbotthepony.mc.otm.registry

import net.minecraftforge.eventbus.api.IEventBus
import net.minecraftforge.registries.DeferredRegister
import net.minecraftforge.registries.ForgeRegistries
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.data.LootPoolAppender
import ru.dbotthepony.mc.otm.data.BasicLootAppender
import ru.dbotthepony.mc.otm.data.PlainLootAppender
import ru.dbotthepony.mc.otm.data.RandomizableItemLootAppender

object LootModifiers {
	private val registry = DeferredRegister.create(ForgeRegistries.Keys.GLOBAL_LOOT_MODIFIER_SERIALIZERS, OverdriveThatMatters.MOD_ID)

	init {
		registry.register("loot_appender") { LootPoolAppender.CODEC }
		registry.register("loot_appender_separated") { PlainLootAppender.CODEC }
		registry.register("loot_appender_basic") { BasicLootAppender.CODEC }
		registry.register("randomizable_item_loot_appender") { RandomizableItemLootAppender.Companion }
	}

	internal fun register(bus: IEventBus) {
		registry.register(bus)
	}
}
